;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Driver ceske/slovenske klavesnice v kodech Kamenickych/DKOI-8/Latin-II
;; Na zaklade programu Milana Kurese (BAJT 4/90) zpracoval Jiri Kolafa 1992
;; Drobnosti dodal Zdenek Wagner - Ice Bear Soft
;; Preklad+linkovani (Borland):
;;   tasm kbd /m
;;   tlink kbd /t
;; Disclaimer: Protoze tento produkt je zadarmo, nevztahuje se na nej vubec
;;   zadna zaruka.  Dojde-li po jeho pouziti k poskrabani HD, vybuchu ci
;;   jine zivelni pohrome, mate smulu.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

JUMPS

;;;;;;;;;; podmineny preklad ;;;;;;;;;;

; kodovani cestiny
code   equ     0        ; kod Kamenicky (KEYBCS2)
;code   equ     1        ; kod DKOI-8
;code   equ     2        ; kod Latin II

; rozlozeni klavesnice
layout  equ     0       ; jen minimalni zmeny (cisla->mala pismenka s diakr.,
                        ;   ciselna rada se shiftem dava specialni znaky !@#...
;layout  equ     1       ; nadto [ ; -> dlouha u, 1 -> ;
;layout  equ     2       ; querty 'standard', ciselna rada se shiftem dava cisla
;layout  equ     3       ; quertz 'standard' pro sekretarky (prehazuje z<->y)
                  
; mrtve klavesy pro diakriticka znamenka
;dead1   equ     0       ; 3 mrtve klavesy ( carka=  hacek+  prehlaska` )
dead1   equ     1       ; 1 mrtva klavesa ( carka`  hacek`` prehlaska``` )

; prepinani ceskeho/anglickeho rezimu
;scroll  equ     0       ; bezi jen v ceskem rezimu
scroll  equ     1       ; Scroll Lock prepina anglicky/cesky rezim

; funkce Caps Lock
;caps    equ     0       ; Caps Lock nefunguje na pismenka s diakritikou
caps    equ     1       ; Caps Lock funguje na pismenka s diakritikou
                        ;                                                  v
                        ;  (tzn. ze pri Caps Lock se stisknuti klavesy 3 = S)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
           
DispStr MACRO adrstr
        push    cs
        pop     ds
        mov     dx,offset adrstr
        mov     ah,09h
        int     21h
        ENDM

_TEXT segment
        assume  cs:_TEXT, ds:_TEXT, es:BIOSDATA
; Na rozdil od puvodniho programu M. Kurese obsahuji segment registry to,
; co je uvedeno v prikazu assume.  Kod je prehlednejsi, byt mozna o par
; bytu delsi.
        org     100h
@filename:
        jmp     begin

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

BIOSDATA segment at 0040h
         org    17h
locks    db     ?       ; bit 10h = Scroll Lock flag, bit 40h = Caps Lock
         org    1Ah     ;   bit 20h = Num Lock
bioshead dw     ?       ; pointer
biostail dw     ?       ;   do bufferu klavesnice BIOSu
BIOSDATA ends


;;;;;;;;;; tabulka znaku pro kombinaci mrtva klavesa + znak ;;;;;;;;;;

pisnr   db      'ACDEILNORSTUYZacdeilnorstuyz'  ; znak k prekladu
LPISNR  equ     $-pisnr

IF code eq 0 ;   ACDEILNORSTUYZacdeilnorstuyz     kod Kamenicky
        db      'CDNTZcdntz'  ; +carka (s dava paragraf)
        db      'AIYaiy'  ; +hacek,krouzek,striska
        db      'CDEILNRSTYZcdeilnrstyz'  ; +prehlaska

ELSEIF code eq 1;ACDEILNORSTUYZacdeilnorstuyz     kod DKOI-8
        db      'DNTZcdnstz'  ; +carka,cedilla
        db      'IYiy'  ; +hacek,krouzek,striska
        db      'DEILRSTYZcdeilrstuz'  ; +prehlaska aj.

ELSE            ;ACDEILNORSTUYZacdeilnorstuyz     kod Latin II
        db      'D֑T퍠d'  ; +carka,cedilla
        db      'ҷוY،眅y'  ; +hacek,krouzek,striska
        db      'DINRݚYdinrty'  ; +prehlaska aj.

ENDIF

IF dead1
; jedina mrtva klavesa (carka: stiskni 1x, hacek:2x, prehlaska:3x)
dianr   equ     '`'
ELSE
; tabulka mrtvych klaves (musi nasledovat tabnr)
dianr   db      '=+`'                   ; carka,hacek,prehlaska
ENDIF

IF code eq 0 ;;;;;;;;;; rozlozeni znaku na klavesnici - Kamenicky ;;;;;;;;;;

IF layout eq 0
; minimalni zmeny (meni se ciselna rada (1 -> u s krouzkem) a mrtve klavesy)

;                !"#$%&    '  ()*+,-./0123456789:;<=>?@
tabnr   db      '!"#$%&',27h,'()*+,-./:;<=>?@'

;                ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_`
        db      'ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_`'

;                abcdefghijklmnopqrstuvwxyz{|}~
        db      'abcdefghijklmnopqrstuvwxyz{|}~'

LENTAB  equ     $-tabnr

IFDEF caps
;                !"#$%&    '  ()*+,-./0123456789:;<=>?@
        db      '!"#$%&',27h,'()*+,-./:;<=>?@' ;!!

;                ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_`
        db      'ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_`'

;                abcdefghijklmnopqrstuvwxyz{|}~
        db      'abcdefghijklmnopqrstuvwxyz{|}~'
ENDIF

ELSEIF layout eq 1
; minimalni zmeny + dlouha u, 1->;

;                !"#$%&    '  ()*+,-./0123456789:;<=>?@
tabnr   db      '!"#$%&',27h,'()*+,-./;:<=>?@'

;                ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_`
        db      'ABCDEFGHIJKLMNOPQRSTUVWXYZ\]^_`'

;                abcdefghijklmnopqrstuvwxyz{|}~
        db      'abcdefghijklmnopqrstuvwxyz{|}~'

LENTAB  equ     $-tabnr

IFDEF caps
;                !"#$%&    '  ()*+,-./0123456789:;<=>?@
        db      '!"#$%&',27h,'()*+,-./;:<=>?@' ;!!

;                ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_`
        db      'ABCDEFGHIJKLMNOPQRSTUVWXYZ\]^_`'

;                abcdefghijklmnopqrstuvwxyz{|}~
        db      'abcdefghijklmnopqrstuvwxyz{|}~'
ENDIF

ELSE
; 'standard' zprehazeni klavesnice, takze se na ni neda nic najit

;                !"#$%&'()*+,-./0123456789:;<=>?@
tabnr   db      '1!3457908+,=.-+"?=:_2'

;                ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_`
        db      'ABCDEFGHIJKLMNOPQRSTUVWXYZ\)6%`'

;                abcdefghijklmnopqrstuvwxyz{|}~
        db      'abcdefghijklmnopqrstuvwxyz/|(;'

LENTAB  equ     $-tabnr

IFDEF caps
;                !"#$%&'()*+,-./0123456789:;<=>?@
        db      '1!3457908+,=.-+"?=:_2'

;                ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_`
        db      'ABCDEFGHIJKLMNOPQRSTUVWXYZ\)6%`'

;                abcdefghijklmnopqrstuvwxyz{|}~
        db      'abcdefghijklmnopqrstuvwxyz/|(;'
ENDIF

ENDIF

ELSEIF code eq 1 ;;;;;;;;;; rozlozeni znaku na klavesnici - DKOI8 ;;;;;;;;;;

IF layout eq 0
; minimalni zmeny (meni se ciselna rada (1 -> u s krouzkem) a mrtve klavesy)

;                !"#$%&    '  ()*+,-./0123456789:;<=>?@
tabnr   db      '!"#$%&',27h,'()*+,-./:;<=>?@'

;                ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_`
        db      'ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_`'

;                abcdefghijklmnopqrstuvwxyz{|}~
        db      'abcdefghijklmnopqrstuvwxyz{|}~'

LENTAB  equ     $-tabnr

IFDEF caps
;                !"#$%&    '  ()*+,-./0123456789:;<=>?@
        db      '!"#$%&',27h,'()*+,-./:;<=>?@'

;                ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_`
        db      'ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_`'

;                abcdefghijklmnopqrstuvwxyz{|}~
        db      'abcdefghijklmnopqrstuvwxyz{|}~'
ENDIF

ELSEIF layout eq 1
; minimalni zmeny + dlouha u, 1->;

;                !"#$%&    '  ()*+,-./0123456789:;<=>?@
tabnr   db      '!"#$%&',27h,'()*+,-./;:<=>?@'

;                ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_`
        db      'ABCDEFGHIJKLMNOPQRSTUVWXYZ\]^_`'

;                abcdefghijklmnopqrstuvwxyz{|}~
        db      'abcdefghijklmnopqrstuvwxyz{|}~'

LENTAB  equ     $-tabnr

IFDEF caps
;                !"#$%&    '  ()*+,-./0123456789:;<=>?@
        db      '!"#$%&',27h,'()*+,-./;:<=>?@'

;                ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_`
        db      'ABCDEFGHIJKLMNOPQRSTUVWXYZ\]^_`'

;                abcdefghijklmnopqrstuvwxyz{|}~
        db      'abcdefghijklmnopqrstuvwxyz{|}~'
ENDIF

ELSE
; 'standard' zprehazeni klavesnice, takze se na ni neda nic najit

;                !"#$%&'()*+,-./0123456789:;<=>?@
tabnr   db      '1!3457908+,=.-+"?=:_2'

;                ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_`
        db      'ABCDEFGHIJKLMNOPQRSTUVWXYZ\)6%`'

;                abcdefghijklmnopqrstuvwxyz{|}~
        db      'abcdefghijklmnopqrstuvwxyz/|(;'

LENTAB  equ     $-tabnr

IFDEF caps
;                !"#$%&'()*+,-./0123456789:;<=>?@
        db      '1!3457908+,=.-+"?=:_2'

;                ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_`
        db      'ABCDEFGHIJKLMNOPQRSTUVWXYZ\)6%`'

;                abcdefghijklmnopqrstuvwxyz{|}~
        db      'abcdefghijklmnopqrstuvwxyz/|(;'
ENDIF

ENDIF

ELSE ;;;;;;;;;; rozlozeni znaku na klavesnici - Latin II ;;;;;;;;;;

IF layout eq 0
; minimalni zmeny (meni se ciselna rada (1 -> u s krouzkem) a mrtve klavesy)

;                !"#$%&    '  ()*+,-./0123456789:;<=>?@
tabnr   db      '!"#$%&',27h,'()*+,-./젡:;<=>?@'

;                ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_`
        db      'ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_`'

;                abcdefghijklmnopqrstuvwxyz{|}~
        db      'abcdefghijklmnopqrstuvwxyz{|}~'

LENTAB  equ     $-tabnr

IFDEF caps
;                !"#$%&    '  ()*+,-./0123456789:;<=>?@
        db      '!"#$%&',27h,'()*+,-./޷:;<=>?@'

;                ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_`
        db      'ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_`'

;                abcdefghijklmnopqrstuvwxyz{|}~
        db      'abcdefghijklmnopqrstuvwxyz{|}~'
ENDIF

ELSEIF layout eq 1
; minimalni zmeny + dlouha u, 1->;

;                !"#$%&    '  ()*+,-./0123456789:;<=>?@
tabnr   db      '!"#$%&',27h,'()*+,-./;젡:<=>?@'

;                ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_`
        db      'ABCDEFGHIJKLMNOPQRSTUVWXYZ\]^_`'

;                abcdefghijklmnopqrstuvwxyz{|}~
        db      'abcdefghijklmnopqrstuvwxyz{|}~'

LENTAB  equ     $-tabnr

IFDEF caps
;                !"#$%&    '  ()*+,-./0123456789:;<=>?@
        db      '!"#$%&',27h,'()*+,-./;:<=>?@'

;                ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_`
        db      'ABCDEFGHIJKLMNOPQRSTUVWXYZ\]^_`'

;                abcdefghijklmnopqrstuvwxyz{|}~
        db      'abcdefghijklmnopqrstuvwxyz{|}~'
ENDIF

ELSE
; 'standard' zprehazeni klavesnice, takze se na ni neda nic najit
; (znaky |`; jsou jinak nez na tom paskvilu, ktery nabizi DOS5.0)
;                !"#$%&'()*+,-./0123456789:;<=>?@
tabnr   db      '1!3457908+,=.-+젡"?=:_2'

;                ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_`
        db      'ABCDEFGHIJKLMNOPQRSTUVWXYZ\)6%`'

;                abcdefghijklmnopqrstuvwxyz{|}~
        db      'abcdefghijklmnopqrstuvwxyz/|(;'

LENTAB  equ     $-tabnr

IFDEF caps
;                !"#$%&'()*+,-./0123456789:;<=>?@
        db      '1!3457908+,=.-+"?=:_2'

;                ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_`
        db      'ABCDEFGHIJKLMNOPQRSTUVWXYZ\)6%`'

;                abcdefghijklmnopqrstuvwxyz{|}~
        db      'abcdefghijklmnopqrstuvwxyz/|(;'
ENDIF

ENDIF

ENDIF ;;;;;;;;;; konec tabulek pro preklad znaku ve vsech kodech ;;;;;;;;;;

IF layout eq 3
; tabulka pro prohozeni z <-> y
;               ^z  ^y  ^z
tabzy   db      1Ah,19h,1Ah,'ZYZzyz'
ENDIF

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

diakr   dw      0       ; 0:        nebyla stisknuta mrtva klavesa
                        ; LPISNR:   byla carka
                        ; LPISNR*2: byl hacek
                        ; LPISNR*3: byla prehlaska
newscan db      0       ; novy scan code
oldscan db      0       ; stary scan code
head    dw      ?       ; pointer
tail    dw      ?       ;   do bufferu klavesnice BIOSu
ofs_09  dw      ?       ; adresa
seg_09  dw      ?       ;   puvodniho INT 09h


;;;;;;;;;;;;;;; vlastni rezidentni driver - obsluha int 09h ;;;;;;;;;;;;;;;;;;

int09   proc    near
        push    ds
        push    es
        push    si
        push    di
        push    dx
        push    cx
        push    bx
        push    ax
        mov     cx,0040h                ; es := segment pro BIOS data
        mov     es,cx
        mov     cx,cs                   ; ds := _TEXT
        mov     ds,cx
        mov     cx,bioshead             ; schova pointer do bufferu
        mov     head,cx                 ;   klavesnice BIOSu
        mov     cx,biostail
        mov     tail,cx
        mov     ah,newscan              ; scan kody:
        in      al,60h                  ;   novy do newscan,
        mov     word ptr newscan,ax     ;   stary do oldscan
        pushf                           ; poradek ve stacku (call misto int)
        call    dword ptr ofs_09        ; puvodni INT 09h

; stav bufferu klavesnice
        mov     bx,tail
        cmp     biostail,bx             ; zmena bufferu?
        mov     ax,word ptr es:[bx]     ; ax:=posledni znak
        jz      end09                   ; buffer se nepohnul -> konec

        sub     bx,bx
IF scroll
; test Scroll Lock
; Scroll Lock sviti = cesky rezim
; Scroll Lock nesviti = anglicky rezim
        mov     cl,locks
        and     cl,10h
        jnz     L7                      ; scroll lock je: pokracovat
; scroll lock neni
        mov     diakr,bx                ; nulovani mrtve klavesy
; pozn. toto neni dokonale - opakovany stisk Scroll Locku nerusi nastavenou
; mrtvou klavesu, je-li ale v anglickem rezimu cokoliv stisknuto, pri dalsim
; prechodu do ceskeho rezimu je jiz mrtva klavesa zrusena
        jz      end09                   ; -> konec
L7:
ENDIF

; do bufferu byl ulozen znak
        or      ah,ah
        jz      end09                   ; byl to Alt-nnn -> konec

IF layout eq 3
; prohozeni z <-> y pro zvlast zavile sekretarky
        push    es
        mov     cx,ds
        mov     es,cx                   ; ! es:=ds
        mov     cx,9
        mov     di,offset tabzy
        cld
        repne   scasb
        jne     L0
        mov     al,byte ptr [di]
L0:     pop     es                      ; obnovim es=BIOSDATA
ENDIF

        cmp     byte ptr oldscan,0E0h   ; rozsireny kod?
        jnz     L2                      ; neni
; rozsireny kod
        mov     diakr,bx                ; zrusim mrtvou klavesu
        jmp     end09                   ; -> konec
L2:


IF dead1 ;;;;;;;;;;;;;;;;;;;;;;; jedna mrtva klavesa ;;;;;;;;;;;;;;;;;;;;;;;;;;

        cmp     al,dianr                ; mrtva klavesa?
        jne     LY                      ; ne (zde bx=0)

; byla stisknuta mrtva klavesa
        mov     bx,diakr
        cmp     bx,LPISNR*2             ; stisknuta poctvrte -> prevod na znak
        ja      LX
        add     bx,LPISNR               ; pridam delku tabulky k diakr
        mov     diakr,bx                ; schovam
        mov     si,offset head
        mov     di,offset bioshead
        movsw                           ; obnovim puvodni stav bufferu
        movsw                           ;   klavesnice BIOSu
;        mov     cx,head
;        mov     bioshead,cx
;        mov     cx,tail
;        mov     biostail,cx
        jmp     ven

LX:     sub     bx,bx
LY:     cmp     bx,diakr                ; byla minule mrtva klavesa?
        jz      ne_dia                  ; ne

; doplnim diakriticke znamenko podle minule mrtve klavesy
        xchg    bx,diakr                ; zaroven nuluji diakr (bx=0)
        push    es
        mov     cx,ds
        mov     es,cx                   ; ! es:=ds
        mov     cx,LPISNR
        mov     di,offset pisnr
        repne   scasb
        pop     es
        jne     end09                   ; nelze doplnit -> necham znak bez zn.
        sub     ah,ah                   ; doplneno, predstiram Alt-nnn
        mov     al,byte ptr [bx+di-1]   ;   (AH:=0, AL:=novy znak)
        jmp     end09

ne_dia: cmp     ah,36h                  ; funkcni klavesa?
        ja      end09                   ;   -> konec
        cmp     al,21h                  ; ctrl?
        jb      end09                   ;   -> konec
        cmp     al,7Fh                  ; ext ASCII?
        ja      end09                   ;   -> konec
        mov     di,offset tabnr

ELSE ;;;;;;;;;;;;;;;;;;;;;;;; tri mrtve klavesy ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

L2:     cmp     bx,diakr                ; byla minule mrtva klavesa?
        jz      ne_dia                  ; ne

; doplnim diakriticke znamenko podle minule mrtve klavesy
        xchg    bx,diakr                ; zaroven nuluji diakr
        push    es
        mov     cx,ds
        mov     es,cx                   ; ! es:=ds
        mov     cx,LPISNR
        mov     di,offset pisnr
        repne   scasb
        pop     es
        jne     end09                   ; nelze doplnit -> necham znak bez zn.
        sub     ah,ah                   ; doplneno, predstiram Alt-nnn
        mov     al,byte ptr [bx+di-1]   ;   (AH:=0, AL:=novy znak)
        jmp     end09

ne_dia: cmp     ah,36h                  ; funkcni klavesa?
        ja      end09                   ;   -> konec
        cmp     al,21h                  ; ctrl?
        jb      end09                   ;   -> konec
        cmp     al,7Fh                  ; ext ASCII?
        ja      end09                   ;   -> konec
        push    es
        mov     cx,ds
        mov     es,cx                   ; ! es:=ds
        mov     cx,3                    ; mrtva klavesa?
        mov     di,offset dianr
        repne   scasb
        pop     es
        jne     L5                      ; nebylo diakr.zn. (DI=tabnr)

; bylo stisknuto diakr.zn.
        neg     cx
        add     cx,3
        mov     ax,LPISNR
        mul     cx
        mov     diakr,ax                ; schovam jeho adresu
        mov     si,offset head
        mov     cx,tail                 ; obnovim puvodni stav bufferu
        mov     biostail,cx             ;   klavesnice BIOSu
        mov     cx,head
        mov     bioshead,cx
        jmp     ven

ENDIF ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; byl stisknut normalni znak, ktery transformuji do cestiny z tabnr
; di=tabnr (pozor, spinave triky!)
L5:
IF caps
        mov     cl,locks                ; test caps lock
        and     cl,40h
        jz      L6                      ; caps lock neni
        add     al,LENTAB               ; caps lock je
ENDIF
L6:     mov     bx,di
        sub     al,21h
        xlat
end09:  mov     bx,tail                 ; prepisu posledni znak v bufferu
        mov     word ptr es:[bx],ax     ;   klavesnice BIOSu
ven:    pop     ax
        pop     bx
        pop     cx
        pop     dx
        pop     di
        pop     si
        pop     es
        pop     ds
        iret
int09   endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; right musi byt tesne za koncem int09

right   db      13,10,"US/"
IF code eq 0
        db      "Kamenicky"
ELSEIF code eq 1
        db      "DKOI-8"
ELSE
        db      "Latin-II"
ENDIF
        db      " driver klavesnice "
IF layout eq 0
        db      "minimum ;[ / querty"
ELSEIF layout eq 1
        db      "minimum uu / querty"
ELSEIF layout eq 2
        db      "sekretarka / querty"
ELSE
        db      "sekretarka / quertz"
ENDIF
IF scroll
        db      " / ScrLock"
ENDIF
IF scroll
        db      " / CapsLock"
ENDIF
IF dead1
        db      " / ```"
ELSE
        db      " / =+`"
ENDIF
        db      13,10,"(c) M.Kures J.Kolafa Z.Wagner 1990-92",13,10,"$"

msgh    db      13,10,"Residentni driver CS klavesnice",13,10
        db      "Pouziti: KBD [/u(volni)] [/h(elp)]",13,10
        db      "Diakriticka znamenka: "
IF dead1
        db      "`(carka) ``(hacek) ```(prehlaska)",13,10
ELSE
        db      "=(carka) +(hacek) `(prehlaska)",13,10
ENDIF
        db      "Znak, ke kteremu nelze pridat diakriticke znamenko, se nemeni"
        db      13,10
IF layout le 1
        db      "Paragraf se ziska jako carkovane s nebo S",13,10
ENDIF
IF scroll
        db      "<Scroll Lock> prepina anglicky a cesky rezim",13,10
ENDIF
        db      13,10,"$"

msg1    db      "Instalovan (volej s parametrem /h pro help)",13,10,"$"
msg2    db      "Uz byl instalovan",13,10,"$"
msg3    db      "Nelze uvolnit",13,10,"$"
msg4    db      "Neni instalovan",13,10,"$"
msg5    db      "Uvolnen",13,10,"$"
msg6    db      "Chybny parametr",13,10,"$"


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; instalace ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; tady jsem skoro nic nemenil, protoze tomu nerozumim (JK)

begin   proc    near
        assume  cs:_TEXT, ds:_TEXT, es:_TEXT, ss:_TEXT

        mov     word ptr [@filename],1234h    ; zamezim nalezeni falesne kopie
        mov     si,80h                        ; zacatek parametru
        cmp     byte ptr [si],0
        jne     @1
        jmp     neprm

@1:     mov     cl,[si]
        xor     ch,ch
        inc     si
        cld
parse:  lodsb                            ; hledam parametr
        cmp     al,"/"
        je      param
        cmp     al,"-"
        je      param
epars:  loop    parse
        jmp     neprm                    ; parametr nebyl nalezen

help:   DispStr right
        DispStr msgh
        jmp     ok_exit

; vyhodnoceni parametru /xxx nebo -xxx
param:  and     byte ptr [si],0DFh       ; upper case
        cmp     byte ptr [si],"U"
        jne     pahe
        jmp     uvolni

pahe:   cmp     byte ptr [si],"H"
        jne     erpar
        jmp     help

erpar:  DispStr msg6
        mov     dx,offset msgh
        jmp     er_exit

uvolni: call    je_tam
        jc      @2
        mov     dx,offset msg4
        jmp     er_exit

@2:     push    es                      ; ES adresuje rezidentni kopii
        pop     ds
        xor     ax,ax
        mov     es,ax
        mov     ax,ds
        cmp     ax,es:[09h*4+2]         ; nelze uvolnit, kdyz INT 09h vektor
        mov     dx,offset msg3          ;   miri jinam
        jne     er_exit
        push    ds
        pop     es
        mov     ax,2509h
        mov     dx,es:[ofs_09]
        mov     ds,es:[seg_09]
        int     21h
        mov     word ptr es:[@filename],0FFFFh ; menim kopii, aby se uz nenasla
        push    es                      ; uvolnim pamet rezid. kopie
        mov     ah,49h
        int     21h
        pop     ds
        mov     ax,word ptr ds:[2Ch]    ; uvolnim pamet environmentu
        mov     es,ax
        mov     ah,49h
        int     21h
        push    cs
        pop     ds
        DispStr msg5
ok_exit: mov    ax,4C00h                ; exit errorlevel=0
        int     21h

; budu instalovat
neprm:  call    je_tam
        jnc     instal
        mov     dx,offset msg2          ; uz tam byl -> chyba

er_exit: push   cs
        pop     ds
        mov     ah,09h
        int     21h
        mov     ax,4C01h                ; exit errorlevel=1
        int     21h

instal: mov     ax,3509h                ; get interrupt 09h
        int     21h
        mov     word ptr [ofs_09],bx    ; schovam puvodni vektor INT 09h
        mov     word ptr [seg_09],es
        lea     dx,int09                ; nastavim svuj driver na INT 09h
        mov     ax,2509h
        int     21h
        DispStr right
        DispStr msg1
        mov     ax,3100h                ; uvolnim nepotrebnou pamet a konec
        mov     dx,(offset right - offset _TEXT + 15) shr 4
        int     21h

begin   endp

; hledani kopie programu v pameti
je_tam  proc    near
        assume  cs:_TEXT, ds:_TEXT, es:_TEXT, ss:_TEXT
        mov     bx,60h                  ; zacatek porovnavani
        mov     ax,cs                   ; konec porovnavani
        cld
@4:     inc     bx
        cmp     ax,bx
        mov     es,bx
        je      end_s
        mov     si,offset @filename
        mov     di,si
        mov     cx,64                   ; porovnavam 64 B
        rep     cmpsb
        or      cx,cx
        jnz     @4
        stc                             ; nasel jsem, nastavim CF
        ret
end_s:  clc                             ; nenasel jsem, mazu CF
        ret
je_tam  endp
_TEXT   ends
        END @filename

